//Caption: Program to convert analog filter into digital filter using
//Bilinear Transformation

clear all;
clc;
close;
s = poly(0,'s');
H = (s+0.1)/((s+0.1)^2+16); //Analog IIR filter transfer function
Omega_Analog = 4;
Omega_Digital = %pi/2;
//Finding Sampling Period
T = (2/Omega_Analog)*(tan(Omega_Digital/2))//Sampling period
disp(T,'Sampling Period=')
z = poly(0,'z');
Hz = horner(H,(2/T)*((z-1)/(z+1)))//Bilinear Transformation
disp(H,'Analog IIR Filter Transfer Function H(S)=')
disp(Hz,'Digital IIR Filter Transfer Function H(Z)=')
//Result
//Analog IIR Filter Transfer Function H(S)=   
// 
//        0.1 + s        
//    ---------------    
//                    2  
//    16.01 + 0.2s + s   
// 
// Digital IIR Filter Transfer Function H(Z)=   
// 
//                                       2  
//  - 0.1188662 + 0.0060957z + 0.1249619z   
//    -----------------------------------   
//                                  2       
//        0.9512344 + 0.0006096z + z      
