//Caption: Program for Lattice Structure Realization of FIR Filter
//Finding out the Lattice Filter Structure coefficients
clear;
clc;
H = [2,4/5,3/2,2/3];
x = poly(0,"x");
H = horner(H,1/x);
m = length(coeff(H))-1;
k0 = 2;
A(m,:) = H/k0;
alpha(m,:)= coeff(A(m,:));
k(m)= alpha(m,m+1);
A =[];
A(m,1) =1+0.4*x+0.75*(x^2)+0.3333333*(x^3);
i = 1;
while (m-i)>=1
    temp = [];
    temp = alpha(m-i+1,m-i+2:-1:1);
    B(m-i+1,1) = inv_coeff(temp);
    A(m-i,1)= (A(m-i+1,1)-k(m-i+1)*B(m-i+1,1))/(1-(k(m-i+1))^2);
    temp1 = coeff(A(m-i,1));
    alpha(m-i,1:m-i+1) =  temp1(1:m-i+1);
    k(m-i) = alpha(m-i,m-i+1);
    i = i+1;
end
disp(A,'A=')
disp(B,'B=')
disp([k0 k'],'Lattice Structure Coefficients are k =')
//Result
// A=   
//                               3           
//    1 + 0.0996310x - 7.229D-08x            
//                                       
//                           2            3  
//    1 + 0.16875x + 0.69375x - 3.750D-08x   
//                                           
//                    2            3         
//    1 + 0.4x + 0.75x + 0.3333333x          
// 
// B=   
// 
//    0                              
//                                   
//                          2        
//    0.69375 + 0.16875x + x         
//                                   
//                            2   3  
//    0.3333333 + 0.75x + 0.4x + x   
// 
// Lattice Structure Coefficients are k =   
 // 2.    0.0996310    0.69375    0.3333333 
 
