//Caption: Program for Lattice Structure Realization of FIR Filter
//Finding out the Lattice Filter Structure coefficients

clear;
clc;
H = [1,-1.334335,0.9025];
x = poly(0,"x");
H = horner(H,1/x);
m = length(coeff(H))-1;
A(m,:) = H;
alpha(m,:)= coeff(A(m,:));
k(m)= alpha(m,m+1);
A =[];
A(m,1) =1-1.334335*x+0.9025*(x^2);
i = 1;
while (m-i)>=1
    temp = [];
    temp = alpha(m-i+1,m-i+2:-1:1);
    B(m-i+1,1) = inv_coeff(temp);
    A(m-i,1)= (A(m-i+1,1)-k(m-i+1)*B(m-i+1,1))/(1-(k(m-i+1))^2);
    temp1 = coeff(A(m-i,1));
    alpha(m-i,1:m-i+1) =  temp1(1:m-i+1);
    k(m-i) = alpha(m-i,m-i+1);
    i = i+1;
end
disp(A,'A=')
disp(B,'B=')
disp(k,'Lattice Structure Coefficients are k =')
//Result
//A=   
// 
//    1 - 0.7013587x            
//                              
//                           2  
//    1 - 1.334335x + 0.9025x   
// 
// B=   
// 
//    0                        
//                             
//                          2  
//    0.9025 - 1.334335x + x   
// 
// Lattice Structure Coefficients are k =   
// 
//  - 0.7013587  
//    0.9025 
