//Caption: Parallel Form  Realization of IIR Filter
//Finding the Partial Fraction of Given IIR Filter transfer function

clear;
clc;
z = poly(0,'z');  //Polynomial fucntion of 'z'
N = [0.7*z^2-0.7*0.36]; //Numerator Polynomial of H(z)
D = [z^2+0.1*z-0.72]; //Denominato Polynomial of H(z)
H= syslin('d',N,D); //Filter transfer function
P = pfss(H); //Partial Fraction of H(z)
H1 = horner(P(1),z);
H2 = horner(P(2),z);
H3 = horner(P(3),z);
C1 = coeff(H1(3));
C2 = coeff(H2(3));
H1(2) = H1(2)/C1(1);
H2(2) = H2(2)/C2(1);
H3 = H3/2;
disp(H1,'H1(z)=')
disp(H2,'H2(z)=')
disp(H3/z,'H3(z)=')
//Result
//H1(z)=   
// 
//  - 0.2058824   
//    ---------   
//     0.9 + z    
// 
// H2(z)=   
// 
//  - 0.1441176   
//    ---------   
//   - 0.8 + z    
// 
// H3(z)=   
// 
//    0.35   
//    ----   
//     z     
