//Caption: Periodogram Estimate of Given Discrete Sequence x(n) ={0,1,2,3}
//using DFT
clear;
clc;
close;
N =4; //4-point DFT
x = [0,1,2,3]; //given discrete sequence
X = dft(x,-1); //4-point DFT of given discrete sequence
Pxx = (1/N)*(abs(X).^2); //Peridogram Estimate 
disp(X,'DFT of x(n)is X(k)=')
disp(Pxx,'Peridogram of x(n) is Pxx(k/N)=')
figure(1)
a = gca();
a.data_bounds =[0,0;5,10];
plot2d3('gnn',[1:N],Pxx)
a.foreground = 5; 
a.font_color = 5;
a.font_style = 5;
title('Peridogram Estimate')
xlabel('Discrete Frequency Variable K ----->')
ylabel('Periodogram Pxx (k /N) ---->')
//Result
//DFT of x(n)is X(k)=   
//    6.               
//  - 2. + 2.i         
//  - 2. - 7.348D-16i  
//  - 2. - 2.i         
// 
// Peridogram of x(n) is Pxx(k/N)=   
//    9.  
//    2.  
//    1.  
//    2.  
