//Caption: Determination of Variance of round-off noise
//at the output of cascade realization
//H1(Z) = 1/(1-(1/2)z-1)
//H2(Z) = 1/(1-(1/4)z-1)
//H(Z) = (2/(1-(1/2)z-1))-(1/(1-(1/4)z-1))
clear;
clc;
close;
a1 = (1/2); //pole of first system in cascade connection
a2 = (1/4); //ploe of second system in cascade connection
sigma_e = 1; //quantization noise variance
//Noise variance of H1(Z)
sigma_2 = (1/(1-a2^2))*sigma_e^2//noise variance of second system
//Noise variance of H2(Z)
sigma_1 = 1/(1-a1^2)*sigma_e^2//noise variance of first system
//Nosie variance of H(Z)
sigma = (((2^2)/(1-a1^2))-((2^2)/(1-a1*a2))+(1/(1-a2^2)))*sigma_e^2
noise_variance1 = sigma+sigma_2 //Total noise variance casacade realization I
noise_variance2 = sigma+sigma_1 //Total noise variance casacade realization II
disp(sigma_1,'sigma_1=')
disp(sigma_2,'sigma_2=')
disp(noise_variance1,'Total noise variance casacade realization I =')
disp(noise_variance2,'Total noise variance casacade realization II =')
//Result
// sigma_1=    1.3333333  
// sigma_2=    1.0666667  
// Total noise variance casacade realization I =    2.8952381  
// Total noise variance casacade realization II =   3.1619048  